libname dur "C:\Users\EDUGUET\FacOuvrages\Ouvrage_Duree\data";


options linesize=64;
goptions htext=1.5;

data duree; set dur.base_handi;
run;

/* loi exponentielle  tat absorbant */
/* partie 2 : estimation globale */

%let tab=duree;
%let y=duree_hand;
%let d=d_hand;
%let inp=_inp; 
%let outp=_outp;
%let outi=_outi;

proc iml;

start lecture;
nom_y={&y}; nom_d={&d};
use &tab; read all var(nom_y) into yi;
read all var(nom_d) into di;
nd=sum(di); n=nrow(yi); nc=n-nd; lyi=log(yi);
print "Time variable =" nom_y,
"Censoring variable (=0 if censored) =" nom_d,
"Number of observations =" n,
"Complete =" nd,
"Censored =" nc;
finish lecture;

start cor(x) global(epsilon);
do i=1 to nrow(x);
x[i]=min(x[i],1-epsilon);
end;
return (x);
finish;

start lv(theta) global(di,yi,lyi,epsilon);
t1=theta[1]; t2=theta[2];
pi=cor(exp(t1)/(1+exp(t1))); h=exp(t2); 
lfi=log(1-pi)+t2-h#yi;
lsi=log(pi+(1-pi)#exp(-h#yi));
lv=sum(di#(lfi-lsi)+lsi);
return (lv);
finish;

start sc(theta) global(di,yi,pi);
t1=theta[1]; t2=theta[2];
pi=cor(exp(t1)/(1+exp(t1))); h=exp(t2); 
st=exp(-h#yi);
spi=pi+(1-pi)#st;
der1=sum((1-di)#pi#(1-pi)#(1-st)/spi-di#pi);
der2=sum(di#(1-h#yi)-(1-di)#(1-pi)#h#yi#st/spi);
der=(der1||der2);
return (der);
finish;

start estim;
use &inp; read all var {pi h} into dzeta0;
print "Exponential distribution with absorbing state",,
"S(t)=pi+(1-pi).exp(-h.t)",;
epsilon=1e-6;
theta0=log(dzeta0[1]/(1-dzeta0[1]))||log(dzeta0[2]);
opt=j(11,1,0); opt[1]=1; opt[2]=1;
call nlpnra(rc,theta,"lv",theta0,opt) grd="sc";
print "Result code (must be >0) =" rc;
call nlpfdd(lv1,gr,he,"lv",theta) grd="sc";
theta=t(theta); gr=t(gr);
elas=abs(theta#gr/lv1);
vp=eigval(he);
print "Log-likelihood at maximum =" lv1,
"Gradient" gr, "Elasticities =" elas, "Hessian eigenvalues =" vp ;
vtheta=inv(-he); 
t1=theta[1]; t2=theta[2];
pi=cor(exp(t1)/(1+exp(t1))); h=exp(t2); 
b=pi//h;
dg=(pi#(1-pi)||0)//(0||h);
vb=dg*vtheta*t(dg);
sb=sqrt(vecdiag(vb));
tb=b/sb;
pb=1-probchi(tb##2,1);
resp=b||sb||tb||pb;
vh=vb[2,2];
mt=1/h; vmt=vh/h##4; smt=sqrt(vmt); tmt=abs(mt)/smt;
pmt=1-probchi(tmt##2,1);
md=log(2)/h; vmd=log(2)##2#vh/h##4; smd=sqrt(vmd); tmd=abs(md)/smd;
pmd=1-probchi(tmd##2,1);
resp=resp//(mt||smt||tmt||pmt)//(md||smd||tmd||pmd);
labc="Parameter"||"Std_Dev"||"Student"||"Pvalue";
labr="Pi (T infinite)"//"H (T finite)"//"Mean (T finite)"
//"Median (T finite)";
print "Estimates",,resp[colname=labc rowname=labr];
finish estim;

start prev;
tmin=0/*min(yi)*/; tmax=30/*max(yi)*/; tby=0.1;
do time=tmin to tmax by tby;
st=exp(-h#time); ft=h#exp(-h#time);
si=pi+(1-pi)#st;
fi=(1-pi)#ft;
hi=fi/si;
ci=1-si;
resi=resi//(time||fi||si||hi||ci);
end;
labi="&y"||"Density"||"SDF"||"Hasard"||"CDF";
finish prev;

start sortie;
create &outp from resp[colname=labc]; append from resp;
create _np from labr[colname="Statistic"]; append from labr;
create &outi from resi[colname=labi]; append from resi;
finish sortie;

run lecture;
run estim;
run prev;
run sortie;

quit;

data &outp; merge _np &outp;
run;


/* graphique 1 */
data tab1; set _outi;
keep duree_hand sdf Fonction;
Fonction="S(t)";
rename sdf=f;
run;

data tab2; set _outi;
keep duree_hand cdf Fonction;
Fonction="F(t)";
rename cdf=f;
run;

data tab; set tab1 tab2;
goptions htext=1.5;
symbol1 c=black i=join v=none line=3;
symbol2 c=black i=join v=none line=1;
proc gplot data=tab;
plot f*duree_hand=fonction/grid;
run;

/* graphique 2 */

data tab1; set _outi;
keep duree_hand hasard Fonction;
Fonction="h(t)";
rename hasard=f;
run;

data tab2; set _outi;
keep duree_hand density Fonction;
Fonction="f(t)";
rename density=f;
run;

data tab; set tab1 tab2;
goptions htext=1.5;
symbol1 c=black i=join v=none line=3;
symbol2 c=black i=join v=none line=1;
proc gplot data=tab;
plot f*duree_hand=fonction/grid;
run;


