/* loi Gamma  trois paramtres */
/* partie 2 : estimation NR  partir du point obtenu par balayage */

libname dur "C:\Users\EDUGUET\FacOuvrages\Ouvrage_Duree\data";

/* VERSION OUVRAGE */


options linesize=64;

data duree; set dur.base_duree;
presence=1-censure;
run;

/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
%let y=duree_emp; /* variable de dure */
%let d=presence; /* indicatrice de dure complte */
%let inp=_inp; /* paramtre en entre */
%let outb=_outb; 
%let outi=_outi; 
%let qs=0.1;

proc iml;
start lecture;
nom_y={&y};
nom_d={&d};
use &tab; read all var(nom_y) into yi;
          read all var(nom_d) into di;
nd=sum(di); n=nrow(yi); nc=n-nd; lyi=log(yi);
print "Time variable =" nom_y,
      "Censoring variable (=0 if censored) =" nom_d,
	  "Number of observations =" n,
	  "Complete =" nd,
	  "Censored =" nc;
finish lecture;

start cphi(x) global(epsilon);
f=1-probnorm(x);
do i=1 to nrow(x);
f[i]=max(f[i],epsilon);
end;
return (f);
finish;

start lphi(x) global(epsilon,pi);
f=-(log(2#pi)+x##2)/2;
return (f);
finish;

start igf(beta,x) global(n,epsilon);
if beta<1e10 then do;
             f=probchi(2#x,2#beta);
             do i=1 to nrow(x);
             f[i]=min(f[i],1-epsilon);
             end;
			 end;
			 else f=j(n,1,0);
return (f);
finish;

start lv(theta) global(di,yi,lyi,qs,flag);
t1=theta[1]; t2=theta[2]; m=theta[3];
q=exp(t1); sigma=exp(t2); 
ui=(lyi-m)/sigma;
if q>qs then do;
        beta=q##(-2); psi=digamma(beta); wi=psi+q#ui;
        lfi=log(q)-t2-lyi-lgamma(beta)+beta#wi-exp(wi);
        lsi=log(1-igf(beta,exp(wi)));
		flag=0;
		end;
		else do; /* log-normal case */
		lfi=lphi(ui)-t2-lyi;
        lsi=log(cphi(ui));
		flag=1;
		end;
lv=sum(di#lfi+(1-di)#lsi);
return (lv);
finish;

start estim;
print "Three-parameter Gamma distribution ",, 
"S(t)=1-g(beta,exp(digamma(beta)+q.u)",
"u=(ln(t)-m)/sigma",
"beta=q^(-2)",
"where g is the incomplete regularized Gamma function",,,
"SECOND STEP : Global optimization",,;
flag=0;
lyi=log(yi);
pi=arcos(-1);
epsilon=1e-6;
qs=&qs;
use &inp; read all var {q sigma m} into dzeta;
theta0=(log(dzeta[1])||log(dzeta[2])||dzeta[3]); 
/*call nlpfdd(f,g,h,"lv",theta0);
print f, g, h;*/
opt=j(11,1,0);
opt[1]=1; opt[2]=1;
call nlpnra(rc,theta,"lv",theta0,opt);
print "Result code (must be >0) =" rc;
call nlpfdd(lv1,g,h,"lv",theta);
g=t(g); theta=t(theta); elas=abs(theta#g/lv1); vp=eigval(h);
print "Log-likelihood at maximum =" lv1,
      "Gradient" g,
      "Elasticities =" elas,
      "Hessian eigenvalues =" vp ;
q=exp(theta[1]); sigma=exp(theta[2]); m=theta[3];
labr="log-likelihood"//"q"//"sigma"//"m";
labc="Statistic"||"Std_Dev"||"Student"||"P_Value";
flag=0;
if flag=0 then do;
/* ajouter le paramtrage prentice */
   vtheta=ginv(-h)+0.05#i(3); 
   beta=1/q##2; alpha=q/sigma; h=exp(digamma(beta)-alpha#m);
   b=beta//alpha//h;
   db=( -2#q##(-3)||0||0 )//
    ( 1/sigma||-q#sigma##(-2)||0 )//
    ( -(2#q##(-3)#trigamma(q##(-2))+m/sigma)#h||
      q#m#sigma##(-2)#h||
     -q#h/sigma);
   vb=db*vtheta*t(db);
   sb=sqrt(vecdiag(vb));
   tb=b/sb;
   pb=1-probchi(tb##2,1);
   labr=labr//"beta"//"alpha"//"h";
   resp=resp//(b1||sb1||tb1||pb1);
   mt=gamma(1/alpha)/(h##(1/alpha)#beta(1/alpha,beta));
   dmt=(mt#(digamma(1/alpha+beta)-digamma(beta)))||
   mt#(log(h)-digamma(1/alpha+beta))/alpha##2||
   -mt/alpha/h;
   vmt=dmt*vb1*t(dmt); smt=sqrt(vmt); tmt=mt/smt;
   pmt=1-probchi(tmt##2,1);
   md=(cinv(0.5,2#beta)/(2#h))##(1/alpha);
   resp=resp//(mt||smt||tmt||pmt)//(md||.||.||.);
   labr1=labr//"Mean"//"Median";
   resp=(lv1||.||.||.)//resp;
   print resp[colname=labc rowname=labr1];
   print "Tests with the Prentice parametrization",,;
   tw=abs(q-1)/sqrt(vtheta[1,1]); pw=1-probchi(tw##2,1);
   print "Test H0: q=1 (Weibull) ", "Statistic =" tw, "p-value =" pw;
   tg2=abs(q-sigma)/sqrt(vtheta[1,1]+vtheta[2,2]-2#vtheta[1,2]); pg2=1-probchi(tg2##2,1);
   print "Test H0: q=sigma (2-parameter Gamma)", "Statistic =" tg2, "p-value =" pg2;
   end; /* fin flag=0*/
   else do; /* dbut flag=1 */
   if q>0 then beta=q##(-2); else beta=.;
   print "The estimated value of beta is equal to =" beta,
   "therefore it is likely that the distribution is LOG-NORMAL"
   ,,,, "RESULTS FOR THE LOG-NORMAL DISTRIBUTION";
   rg=2:3;
   theta=t(theta[rg]); t1=theta[1]; t2=theta[2];
   h=h[rg,rg]; 
   vtheta=inv(-h); 
   b=exp(t1)//t2;
   sigma=b[1]; m=b[2];
   db=(sigma||0)//(0||1);
   vb=db*vtheta*t(db);
   sb=sqrt(vecdiag(vb));
   tb=b/sb;
   pb=1-probchi(tb##2,1);
   resp=b||sb||tb||pb;
   labc="Params"||"Std_Dev"||"Student"||"Pvalue";
   labr1="Log-likelihood"//"Sigma"//"m"//"Mean"//"Median";
   md=exp(m); smd=sqrt(md##2#vb[2,2]); tmd=md/smd; pmd=1-probchi(tmd##2,1);
   mt=exp(m+sigma##2/2); dmt=(sigma#mt||mt);
   smt=sqrt(dmt*vb*t(dmt)); tmt=mt/smt; pmt=1-probchi(tmt##2,1);
   resp=(lv1||.||.||.)//resp//(mt||smt||tmt||pmt)//(md||smd||tmd||pmd);
   start has(x) global(alpha,mu);
   z=alpha#x-mu;
   f=pdf("normal",z,0,1)#alpha/exp(x);
   s=cphi(z);
   has=log(f)-log(s);
   return (has);
   finish;
   opt=j(11,1,0); opt[1]=1; opt[2]=0; alpha=exp(t1); mu=t2; lt0=log(md);
   call nlpnra(rc,lt1,"has",lt0,opt); /* on prend la mdiane comme valeur initiale */
   tmax=exp(lt1); hmax=exp(has(lt1));
   print "The hasard function reaches a maximum at T =" tmax,
      "Its maximum value is h =" hmax;
   print resp[colname=labc rowname=labr1];
   end; /* fin flag=1 */
finish estim;

run lecture;
run estim;
quit;
run;
