/* loi Gamma  trois paramtres */
/* partie 2 : estimation NR  partir du point obtenu par balayage */

libname dur "C:\Users\EDUGUET\FacOuvrages\Ouvrage_Duree\data";

/* VERSION OUVRAGE */


options linesize=64;

data duree; set dur.base_duree;
presence=1-censure;
run;

/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
%let y=duree_emp; /* variable de dure */
%let d=presence; /* indicatrice de dure complte */
%let inp=_inp; /* paramtre en entre */
%let outp=_outp; 
%let outi=_outi; 
%let qs=0.1;
%let tmin=;
%let tmax=;
%let tby=;

proc iml;
start lecture;
nom_y={&y};
nom_d={&d};
use &tab; read all var(nom_y) into yi;
          read all var(nom_d) into di;
nd=sum(di); n=nrow(yi); nc=n-nd; lyi=log(yi);
print "Time variable =" nom_y,
      "Censoring variable (=0 if censored) =" nom_d,
	  "Number of observations =" n,
	  "Complete =" nd,
	  "Censored =" nc;
finish lecture;

start cphi(x) global(epsilon);
f=1-probnorm(x);
do i=1 to nrow(x);
f[i]=max(f[i],epsilon);
end;
return (f);
finish;

start lphi(x) global(epsilon,pi);
f=-(log(2#pi)+x##2)/2;
return (f);
finish;

start igf(beta,x) global(n,epsilon);
if beta<1e10 then do;
             f=probchi(2#x,2#beta);
             do i=1 to nrow(x);
             f[i]=min(f[i],1-epsilon);
             end;
			 end;
			 else f=j(n,1,0);
return (f);
finish;

start lv(theta) global(di,yi,lyi,qs,flag);
t1=theta[1]; t2=theta[2]; m=theta[3];
q=exp(t1); sigma=exp(t2); 
ui=(lyi-m)/sigma;
if q>qs then do;
        beta=q##(-2); psi=digamma(beta); wi=psi+q#ui;
        lfi=log(q)-t2-lyi-lgamma(beta)+beta#wi-exp(wi);
        lsi=log(1-igf(beta,exp(wi)));
		flag=0;
		end;
		else do; /* log-normal case */
		lfi=lphi(ui)-t2-lyi;
        lsi=log(cphi(ui));
		flag=1;
		end;
lv=sum(di#lfi+(1-di)#lsi);
return (lv);
finish;

start estim;
print "Three-parameter Gamma distribution ",, 
"S(t)=1-g(beta,exp(digamma(beta)+q.u)",
"u=(ln(t)-m)/sigma",
"beta=q^(-2)",
"where g is the incomplete regularized Gamma function",,,
"SECOND STEP : Global optimization",,;
flag=0;
lyi=log(yi);
pi=arcos(-1);
epsilon=1e-6;
qs=&qs;
use &inp; read all var {q sigma m} into dzeta;
theta0=(log(dzeta[1])||log(dzeta[2])||dzeta[3]); 
/*call nlpfdd(f,g,h,"lv",theta0);
print f, g, h;*/
opt=j(11,1,0);
opt[1]=1; opt[2]=1;
call nlpnra(rc,theta,"lv",theta0,opt);
print "Result code (must be >0) =" rc;
call nlpfdd(lv1,g,h,"lv",theta);
g=t(g); theta=t(theta); elas=abs(theta#g/lv1); vp=eigval(h);
print "Log-likelihood at maximum =" lv1,
      "Gradient" g,
      "Elasticities =" elas,
      "Hessian eigenvalues =" vp ;
labc="Statistic"||"Std_Dev"||"Student"||"P_Value";
resp=(lv1||.||.||.);
labr="log-likelihood";
/*flag=0;*/
if flag=0 then do;
/*vtheta=ginv(-h)+0.05#i(3);*/
vtheta=inv(-h);
/* paramtrage de Prentice = bp */
q=exp(theta[1]); sigma=exp(theta[2]); m=theta[3];
bp=q//sigma//m;
 dbp=(q||0||0)//(0||sigma||0)//(0||0||1);
 vbp=dbp*vtheta*t(dbp);
 sbp=sqrt(vecdiag(vbp));
 tbp=abs(bp)/sbp;
 pbp=1-probchi(tbp##2,1);
 resp=resp//(bp||sbp||tbp||pbp);
 labr=labr//"q"//"sigma"//"m";
/* Paramtrage de Stacy = bs */
beta=1/q##2; alpha=q/sigma; h=exp(digamma(beta)-alpha#m);
bs=beta//alpha//h;
 dbs=( -2#q##(-3)||0||0 )//
 ( 1/sigma||-q#sigma##(-2)||0 )//
 ( -(2#q##(-3)#trigamma(q##(-2))+m/sigma)#h||
 q#m#sigma##(-2)#h||
 -q#h/sigma);
 vbs=dbs*vbp*t(dbs);
 sbs=sqrt(vecdiag(vbs));
 tbs=abs(bs)/sbs;
 pbs=1-probchi(tbs##2,1);
 resp=resp//(bs||sbs||tbs||pbs);
 labr=labr//"beta"//"alpha"//"h";
 /* dures moyenne et mdiane */
 mt=gamma(1/alpha)/(h##(1/alpha)#beta(1/alpha,beta));
  dmt=(mt#(digamma(1/alpha+beta)-digamma(beta)))||
  mt#(log(h)-digamma(1/alpha+beta))/alpha##2||
  -mt/alpha/h;
  vmt=dmt*vbs*t(dmt); smt=sqrt(vmt); tmt=mt/smt;
  pmt=1-probchi(tmt##2,1);
 md=(cinv(0.5,2#beta)/(2#h))##(1/alpha);
  resp=resp//(mt||smt||tmt||pmt)//(md||.||.||.);
  labr=labr//"Mean"//"Median";
  print resp[colname=labc rowname=labr];
  print "Tests with the Prentice parametrization",,;
 tw=abs(q-1)/sqrt(vbp[1,1]); pw=1-probchi(tw##2,1);
  print "Test H0: q=1 (Weibull) ", "Statistic =" tw, "p-value =" pw;
 tg2=abs(q-sigma)/sqrt(vbp[1,1]+vbp[2,2]-2#vbp[1,2]);
  pg2=1-probchi(tg2##2,1);
  print "Test H0: q=sigma (2-parameter Gamma)", "Statistic =" tg2, "p-value =" pg2;
end; /* fin flag=0*/
else do; /* dbut flag=1 */
q=exp(theta[1]);
if q>0 then beta=q##(-2); else beta=.;
 print "The estimated value of beta is equal to =" beta,
       "therefore it is likely that the distribution is LOG-NORMAL"
       ,,,, "RESULTS FOR THE LOG-NORMAL DISTRIBUTION";
 rg=2:3;
 theta=t(theta[rg]);
 vtheta=inv(-h[rg,rg]);
 /* Paramtrage loi log-normale */
 bn=exp(theta[1])//theta[2]; sigma=bn[1]; m=bn[2];
  dbn=(sigma||0)//(0||1);
  vbn=dbn*vtheta*t(dbn);
  sbn=sqrt(vecdiag(vbn));
  tbn=abs(bn)/sbn;
  pbn=1-probchi(tbn##2,1);
  resp=resp//(bn||sbn||tbn||pbn);
  labr=labr//"sigma"//"m";
 md=exp(m);
  smd=sqrt(md##2#vbn[2,2]); tmd=md/smd; pmd=1-probchi(tmd##2,1);
 mt=exp(m+sigma##2/2); dmt=(sigma#mt||mt);
  smt=sqrt(dmt*vbn*t(dmt)); tmt=mt/smt; pmt=1-probchi(tmt##2,1);
 resp=resp//(mt||smt||tmt||pmt)//(md||smd||tmd||pmd);
 labr=labr//"Mean"//"Median";
 /* maximum de la fonction de hasard */
 start has(x) global(alpha,mu);
  z=alpha#x-mu;
  f=pdf("normal",z,0,1)#alpha/exp(x);
  s=cphi(z);
  has=log(f)-log(s);
  return (has);
 finish;
 opt=j(11,1,0); opt[1]=1; opt[2]=0;
 alpha=1/sigma; mu=m/sigma; lt0=log(md);
 call nlpnra(rc,lt1,"has",lt0,opt); /* on prend la mdiane comme valeur initiale */
 tmax=exp(lt1); hmax=exp(has(lt1));
 print "The hasard function reaches a maximum at T =" tmax,
       "Its maximum value is h =" hmax;
 print resp[colname=labc rowname=labr];
 end; /* fin flag=1 */
finish estim;

start prev;
tmin=0.1/*min(yi)*/; 
tmax=&tmax; if tmax<=0 then tmax=max(yi); tby=0.1;
do time=tmin to tmax by tby;
if flag=0 then do;
   ui=(lyi-m)/sigma;
   beta=q##(-2); psi=digamma(beta); wi=psi+q#ui;
   lfi=log(q)-t2-lyi-lgamma(beta)+beta#wi-exp(wi);
   lsi=log(1-igf(beta,exp(wi)));
   fi=exp(lfi);
   si=exp(lsi);
   ci=1-si;
   hi=fi/si;
   end;
   else do;
   zi=(log(time)-m)/sigma;
   fi=pdf("normal",zi,0,1)/(sigma#time);
   si=cphi(zi);
   hi=fi/si;
   ci=1-si;
   end;
resi=resi//(time||fi||si||hi||ci);
end;
labi="&y"||"Density"||"SDF"||"Hasard"||"CDF";
finish prev;

start sortie;
create &outp from resp[colname=labc]; append from resp;
create _np from labr[colname="Estimate"]; append from labr;
create &outi from resi[colname=labi]; append from resi;
finish sortie;

run lecture;
run estim;
run prev;
run sortie;

quit;

data &outp; merge _np &outp;
run;
