/* estimation des paramtres de la loi de Burr */
options linesize=64;

libname dur "C:\Users\EDUGUET\FacOuvrages\Ouvrage_Duree\data";

data duree; set dur.base_duree;
presence=1-censure;
run;


%let tab=duree; 
%let y=duree_emp; 
%let d=presence; 
%let outp=_outp; 
%let outi=_outi; 
%let inp=_inp;


proc iml;

start lecture;
nom_y={&y};
nom_d={&d};
use &tab; read all var(nom_y) into yi;
          read all var(nom_d) into di;
nd=sum(di); n=nrow(yi); nc=n-nd; lyi=log(yi);
print "Time variable =" nom_y,
      "Censoring variable (=0 if censored) =" nom_d,
	  "Number of observations =" n,
	  "Complete =" nd,
	  "Censored =" nc;
finish lecture;

start lv(theta) global(di,yi,lyi,n,nd); /* 3 parameters likelihood */
t1=theta[1]; t2=theta[2]; t3=theta[3];
a=exp(t1); alpha=exp(t2); h=exp(t3);
lv=n#a#t1+nd#(t1+t2+t3)+sum((alpha-1)#di#lyi-(a+di)#log(a+h#yi##alpha));
return (lv);
finish;

start sc(theta) global(di,yi,lyi,a,nd,n);
t1=theta[1]; t2=theta[2]; t3=theta[3];
a=exp(t1); alpha=exp(t2); h=exp(t3);
hyia=h#yi##alpha;
z1i=a+hyia;
z2i=hyia/(a+hyia);
der1=n#a#(1+t1)+nd-a#sum(log(z1i)+(a+di)/z1i);
der2=nd+alpha#sum((di-(a+di)#z2i)#lyi);
der3=nd-sum((a+di)#z2i);
der=(der1||der2||der3);
return (der);
finish;

start estim;
use &inp; read all var {a alpha h} into dzeta0;
theta0=log(dzeta0);
print dzeta0;
opt=j(11,1,0); opt[1]=1; opt[2]=5;
call nlpnra(rc,theta,"lv",theta0,opt) grd="sc";
call nlpfdd(f,g,he,"lv",theta) grd="sc";
theta=t(theta); 
g=t(g);
elas=g/f#theta;
vp=eigval(he);
print "log-likelihood =" f,
      "Gradient =", g,
      "Elasticities = " elas,
      "Eigenvalues of the hessian =" vp;
vtheta=inv(-he); 
b=exp(theta);
a=b[1]; alpha=b[2]; h=b[3];
dg=(a||0||0)//(0||alpha||0)//(0||0||h);
vb=dg*vtheta*t(dg);
sb=sqrt(vecdiag(vb));
tb=abs(b)/sb;
pb=1-probchi(tb##2,1);
res_b=(b||sb||tb||pb);
labc="Estim"//"Ecart_Type"//"Student"//"PValue"; 
labr="ALPHA"//"H"//"A"//"Mean"//"Median";
test=alpha#a;
if test>1 then do; 
          mt=a#(a/h)##(1/alpha)#beta(a-1/alpha,1+alpha);
		  dmt=(mt#((1/alpha+1)/a+digamma(a-1/alpha)-digamma(a+1))||
		      mt#(-log(a/h)+digamma(a-1/alpha)-digamma(1+1/alpha))/(alpha##2)||
			  -mt/alpha/h);
		  vmt=dmt*vb*t(dmt);
		  smt=sqrt(vecdiag(vmt));
		  tmt=abs(mt)/smt;
		  pmt=1-probchi(tmt##2,1);
		  res_b=res_b//(mt||smt||tmt||pmt);
          end;
          else do; print "La moyenne n'existe pas";
		  res_b=res_b//(.||.||.||.);
          end;
md=(a/h)##(1/alpha)#(2##(1/a)-1)##(1/alpha);
dmd=(
     md#(1-(log(2)/a)#2##(1/a)/(2##(1/a)-1))/(alpha#a)||
    -md/alpha##2#(log(a/h)+log(2##(1/a)-1))||
	-md/alpha/h);
	vmd=dmd*vb*t(dmd);
	smd=sqrt(vecdiag(vmd));
	tmd=abs(md)/smd;
	pmd=1-probchi(tmd##2,1);
    res_b=res_b//(md||smd||tmd||pmd);
if alpha>1 then do; tmax=((alpha-1)#a/h)##(1/alpha); 
           print "Le hasard admet un maximum en T =" tmax;
           end;
test_par=abs(alpha-1)/sb[2]; pval_par=1-probchi(test_par##2,1);
test_log=abs(a-1)/sb[1]; pval_log=1-probchi(test_log##2,1);
 print "Test H0 : Alpha=1 (Pareto) =" test_par,
       "P-value =" pval_par,,,
	   "Test H0 : A=1 (log-logistic) =" test_log,
	   "p-value =" pval_log;
print "Paramtres de la loi de Burr type XII", res_b[colname=labc rowname=labr];
finish estim;

start prev;
/* fonctions usuelles */
tmin=min(yi); tmax=max(yi); tby=1;
do time=0.1 to 30 by 0.1;
si=(a/(a+h#time##alpha))##a;
hi=a#h#alpha#time##(alpha-1)/(a+h#time##alpha);
fi=hi#si;
ci=1-si;
res=res//(time||si||hi||fi||ci);
end;
nres="&y"||"SDF"||"Hasard"||"Density"||"CDF";
finish prev;

start sortie;
create &outp from res_b[colname=labc]; append from res_b;
create _np from labr[colname="Param"]; append from labr;
create &outi from res[colname=nres]; append from res;
finish sortie;

run lecture;
run estim;
run prev;
run sortie;

quit;
run;

data &outp; merge _np &outp;
run;



/* graphique 1 */
data tab1; set _outi;
keep duree_emp sdf Fonction;
Fonction="S(t)";
rename sdf=f;
run;

data tab2; set _outi;
keep duree_emp cdf Fonction;
Fonction="F(t)";
rename cdf=f;
run;

data tab; set tab1 tab2;
goptions htext=1.5;
symbol1 c=black i=join v=none line=3;
symbol2 c=black i=join v=none line=1;
proc gplot data=tab;
plot f*duree_emp=fonction/grid;
run;

/* graphique 2 */

data tab1; set _outi;
keep duree_emp hasard Fonction;
Fonction="h(t)";
rename hasard=f;
run;

data tab2; set _outi;
keep duree_emp density Fonction;
Fonction="f(t)";
rename density=f;
run;

data tab; set tab1 tab2;
goptions htext=1.5;
symbol1 c=black i=join v=none line=3;
symbol2 c=black i=join v=none line=1;
proc gplot data=tab;
plot f*duree_emp=fonction/grid;
run;


