
/* Estimation non paramtrique */
libname dur "C:\Users\EDUGUET\FacOuvrages\OuvrageDuree\data";
options linesize=64;
goptions htext=1.8;

data duree; set dur.base_duree; presence=1-censure;
if sexenq=1 then Groupe="Hommes"; else Groupe="Femmes";

/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
%let y=duree_emp; /* variable de dure */
%let d=presence; /* indicatrice de dure complte */

/* les seuils correspondent aux valeurs des dures*/
/* on les obtient par une procdure freq */
/* cette procdure donne le nombre d'observations total */
/* et censur */

/* avec intervalles par dfaut */
proc lifetest data=&tab method=ACT outsurv=s_act ;
time &y*&d(0); 
run;




/* en mettant des intervalles personnaliss */


proc lifetest data=&tab method=ACT outsurv=s_act 
intervals=1 to 50 by 1;
time &y*&d(0); 
run;

data s_act; set s_act;
label 
survival="S(t)"
pdf="f(t)"
haz_lcl="h(t)"
hazard="h(t)"
&y="T";

proc print;
run;

symbol1 c=black i=stepJR v=none;
proc gplot data=s_act;
plot survival*&y/haxis=0 to 50 by 5;
run;

proc gplot data=s_act;
plot pdf*&y/haxis=0 to 50 by 5;
run;


proc gplot data=s_act;
plot hazard*&y/haxis=0 to 50 by 5;
run;


data s_act; set s_act;
if &y<=45;
symbol1 c=black i=stepJR v=none line=3;
symbol2 c=black i=stepJR v=none line=1;
symbol3 c=black i=stepJR v=none line=3;

proc gplot data=s_act;
plot (haz_lcl hazard haz_ucl)*&y/haxis=0 to 45 by 5 overlay;
run;



/* effectifs */

proc freq noprint data=&tab; tables &y*&d/out=_total(keep=&y &d count);
proc transpose data=_total out=_total(drop=_name_ _label_) prefix=n; by &y; id &d;
data _total; set _total;
/* n0 : nbre d'obs censures, n1 : nbre d'obs compltes */
c=max(n0,0); /* met 0 si aucune obs n'est censure */
d=max(n1,0); /* met 0 si aucune obs n'est complte */ 
ntot=c+d; /* nombre de dures de l'intervalle */
proc sort; by descending &y;

data _total; set _total; by descending &y;/* population  risque */
retain n;
if _N_=1 then n=ntot;
         else n=n+ntot;
proc sort; by &y;
run;

data _total; set _total; by &y;
b=dif(&y);
if _n_=1 then b=&y;
run;

data _total; set _total;
eta=-d/b/(c+d)*log(1-(c+d)/n);
kappa=-c/b/(c+d)*log(1-(c+d)/n);
logl=
-(n-c-d)*b*(eta+kappa)+d*log(eta/(eta+kappa))+c*log(kappa/(eta+kappa))
+(d+c)*log(1-exp(-(eta+kappa)*b));
proc means noprint; var logl; output out=_sortie sum=logl;
proc print;
run;
