
/* Estimation non paramtrique */
libname dur "C:\Users\EDUGUET\FacOuvrages\OuvrageDuree\data";
options linesize=64;
goptions htext=1.8;

data duree; set dur.base_duree; presence=1-censure;
if sexenq=1 then Groupe="Hommes"; else Groupe="Femmes";

/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
%let y=duree_emp; /* variable de dure */
%let d=presence; /* indicatrice de dure complte */

/* les seuils correspondent aux valeurs des dures*/
/* on les obtient par une procdure freq */
/* cette procdure donne le nombre d'observations total */
/* et censur */

/* avec intervalles par dfaut 
proc lifetest data=&tab method=ACT outsurv=s_act ;
time &y*&d(0); 
run;*/




/* en mettant des intervalles personnaliss */


proc lifetest data=&tab method=ACT outsurv=s_act 
intervals=1 to 50 by 1;
time &y*&d(0); 
run;

data s_act; set s_act;
label 
survival="S(t)"
pdf="f(t)"
haz_lcl="h(t)"
hazard="h(t)"
&y="T";
/*
proc print;
run;

symbol1 c=black i=stepJR v=none;
proc gplot data=s_act;
plot survival*&y/haxis=0 to 50 by 5;
run;

proc gplot data=s_act;
plot pdf*&y/haxis=0 to 50 by 5;
run;


proc gplot data=s_act;
plot hazard*&y/haxis=0 to 50 by 5;
run;


data s_act2; set s_act;
if &y<=45;
symbol1 c=black i=stepJR v=none line=3;
symbol2 c=black i=stepJR v=none line=1;
symbol3 c=black i=stepJR v=none line=3;

proc gplot data=s_act2;
plot (haz_lcl hazard haz_ucl)*&y/haxis=0 to 45 by 5 overlay;
run;

*/

/* effectifs */

proc freq noprint data=&tab; tables &y*&d/out=_nbres(keep=&y &d count);

proc transpose data=_nbres out=_nbres(drop=_name_ _label_) prefix=n; by &y; id &d;
proc means sum;
run;
data _nbres; set _nbres;
c=max(n0,0); /* met 0 si aucune obs n'est censure */
d=max(n1,0); /* met 0 si aucune obs n'est complte */ 
tot=c+d;
run;
data _nbres; merge _nbres(in=ta) s_act(in=tb); by &y;
if tot>0.;
proc sort; by descending &y;
data _nbres; set _nbres; by descending &y;
retain n; /* number at risk */
if _n_=1 then n=tot; else n=n+tot;
proc sort; by &y;
run; 

/* estimateur actuariel */
data _nbres; set _nbres; by &y;
nc=n-(c+d)/2;
h=d/nc;
b=dif(&y);
if _n_=1 then b=&y;
run;

data _nbres; set _nbres; by &y;
retain s1;
if _n_=1 then s1=1-h; else s1=s1*(1-h);
/*keep hazard h survival s1;*/
run;

data _nbres; set _nbres;
eta=-d/b/(c+d)*log(1-(c+d)/n);
kappa=-c/b/(c+d)*log(1-(c+d)/n);
ch=exp(-eta*b);
h=1-exp(-eta*b);
/*hs=d/(n-(c+d)/2);*/

data _nbres; set _nbres; by &y;
retain s s2;
if _n_=1 then s=ch; else s=s*ch;
run;

data _nbres; set _nbres;
logl=d*log(pdf)+c*log(survival);
logl2=-(n-c-d)*b*(eta+kappa)+d*log(eta/(eta+kappa))+c*log(kappa/(eta+kappa))
+(c+d)*log(1-exp(-(eta+kappa)*b));
f=-dif(s);
if _n_=1 then f=h;
keep &y  hazard h  survival s pdf f logl logl2;
proc means sum; var logl logl2 ;
run;
