libname dur "C:\Users\EDUGUET\FacOuvrages\OuvrageDuree\data";

/* VERSION OUVRAGE */


/* estimation des paramtres de la loi de Weibull */

options linesize=64;

data duree; set dur.base_duree;
presence=1-censure;
c_nais1=(anaisenq<=1948);
c_nais2=(1948<anaisenq<=1958);
c_nais3=(1958<anaisenq<=1968);
c_nais4=(1968<anaisenq<=1978);
c_nais5=(1978<anaisenq<=1988);
run;

/* paramtres du programme */
%let tab=duree; /* nom du tableau SAS contenant les donnes */
%let y=duree_emp; /* variable de dure */
%let x=/*dip_pri*/ dip_sec dip_sup /*gen_h*/  gen_f/*france d_metr d_petr*/ /*c_nais2 c_nais3 c_nais4*/
c_nais2 c_nais3 c_nais4 c_nais5;
%let d=presence; /* indicatrice de dure complte */
/* centrage des variables */

proc standard data=&tab out=_tab mean=0; var &x; run;

proc lifereg data=_tab outest=_b;
model &y*&d(0)=&x;
run;

/*hasard de base*/
data _h0; set _b(keep=intercept _scale_);
h=exp(-intercept);
alpha=1/_scale_;
do t=0 to 30 by 0.01;
s0=exp(-h*t**alpha);
c0=1-s0;
h0=h*alpha*t**(alpha-1);
f0=h0*s0;
output;
end;
run;

symbol1 c=black line=1 v=none i=join;
symbol2 c=black line=3 v=none i=join;

proc gplot data=_h0;
plot (h0 f0)*t/overlay;
run;
